/* YOODA : Yet another Object Oriented Database
   Copyright (C) 1994  Eric Abecassis

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.

You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */


/*****************************************************************************
******************************************************************************
**                                                                            
**        Y     Y   OOOO    OOOO   DDDDD     AA
**         Y   Y   O    O  O    O  D    D   A  A
**          Y Y    O    O  O    O  D    D  A    A 
**           Y     O    O  O    O  D    D  AAAAAA
**           Y     O    O  O    O  D    D  A    A
**           Y      OOOO    OOOO   DDDDD   A    A
**
******************************************************************************
******************************************************************************/
/*****************************************************************************
*
*  MODULE :             Page Allocation management
*  SCOPE :              Implements allocation for YOODA volumes
*  FILE :               volallocator.hxx
*  AUTHORS :            E. Abecassis
*  CREATION DATE :      August 1, 1993
*  COPYRIGHTS :        (C) E. Abecassis, 1993
*  HISTORY :
*
******************************************************************************/

#ifdef __GNUG__
#pragma interface
#endif
#ifndef __volallocator_HXX
#define __volallocator_HXX

/* IMPORTS *******************************************************************/

#ifndef __types_H
#define __types_H
#include <sys/types.h>
#endif

#ifndef __class_HXX
#include "class.hxx"
#endif

/*****************************************************************************/

class VolAllocator {

  private :

  caddr_t      _addr ;
  TableOfBits* _table ;
  
  public :

  VolAllocator(int fd) ;
  ~VolAllocator() ;
  int alloc(int number) ;
  void freepage(int number) ;
  int isused(int, int) ;
  static const int SizeInPage ;
} ;

#endif
